!Demonstrator of the following:
!LIST Styles.  LIST Cell & Column Tooltips.  Adjustable Window TIMER.
!Written in C5b. Compiled 32-bits.
!010326:Ron Eisner
!-----------------------------------

  PROGRAM
  MAP
pMakeString PROCEDURE(*STRING,LONG,LONG) !Random queue data.
  END !MAP

Q         QUEUE         !LIST FROM() Queue:
Field1      LONG        !Not displayed.
Field2      STRING(50)  !First display field.
Field2Sty   LONG        !First field Style.
Field2Tip   CSTRING(50) !First field Tooltip.
Field3      LONG        !Second display field.
Field3Sty   LONG        !Second field Style.
Field3Tip   CSTRING(50) !Second field Tooltip.
          END

sField1Format STRING(100) !LIST Field 1 FORMAT()
sField2Format STRING(100) !LIST Field 2 FORMAT()
sField3Format STRING(100) !LIST Field 3 FORMAT()
sFormat       STRING(300) !Concatenated format assigned to LIST
sMsg1         STRING(500) !TEXT Description field 1
sMsg2         STRING(500) !TEXT Description field 2
sMsg3         STRING(500) !TEXT Description field 3

ilCounter     LONG        !To give TIMER something to do.
ilElapsing    LONG        !Elapsing time.
ilSpinTimer   LONG        !To set Window{Prop:Timer}=ilSpinTimer
ilSpinLow     LONG(0)     !Timer limit
ilSpinHigh    LONG(6553)  !Timer limit
ilStartTime   LONG        !Time TIMER first turned on.

Window WINDOW('LIST Styles and Cell Tooltips'),AT(,,271,200),CENTER,STATUS,SYSTEM,GRAY,DOUBLE
       LIST,AT(4,8,141,185),USE(?List1),HVSCROLL,TIP('Overall LIST Toolip'),FORMAT('50LPY|M~Field1~@S50@#2#50L~Field2~@N10@#5#'), |
           FROM(Q)
       TEXT,AT(156,8,109,53),USE(sMsg1),VSCROLL,CENTER,COLOR(080FFH),READONLY
       TEXT,AT(156,64,109,93),USE(sMsg2),VSCROLL,CENTER,COLOR(0808040H),READONLY
       TEXT,AT(156,160,109,21),USE(sMsg3),VSCROLL,CENTER,COLOR(COLOR:Green),READONLY
       SPIN(@n4),AT(156,184,30,10),USE(ilSpinTimer),IMM,RIGHT,TIP('Window{{Prop:Timer}<13,10,13,10>( 0 - 6553 )'), |
           RANGE(-1,6554),STEP(1)
       BUTTON('&Restore'),AT(192,184,32,11),USE(?bRestore)
       BUTTON('E&xit'),AT(232,184,32,11),USE(?bExit),DEFAULT
     END


  CODE
  DO rSetListFormat
  DO rSetFields
  DO rLoadQ
  OPEN(Window)
  DO rSetStyle
  ?List1{PROP:Format} = CLIP(sFormat)
  ilStartTime = CLOCK()
  ilElapsing  = CLOCK()
  DO rTimer

  ACCEPT
    CASE EVENT()
    OF Event:Accepted
      CASE FIELD()
      OF ?bExit
        BREAK
      OF ?bRestore
        DO rSetFields
        ?List1{PROP:Format} = CLIP(sFormat)
      OF ?ilSpinTimer
        Window{Prop:Timer} = ilSpinTimer
        DO rTimer
      END !CASE FIELD()
    OF Event:NewSelection
      CASE FIELD()
      OF ?ilSpinTimer
        IF ilSpinTimer > ilSpinHigh
          CHANGE(?ilSpinTimer,ilSpinLow)
        END !IF ilSpinTimer > ilSpinHigh
        IF ilSpinTimer < ilSpinLow
          CHANGE(?ilSpinTimer,ilSpinHigh)
        END !IF ilSpinTimer > ilSpinHigh
        DO rTimer
      END !CASE FIELD()
     OF Event:Timer
        ilCounter += 1
        DO rTimer
    END !CASE EVENT()
  END !ACCEPT

  RETURN

!---------------------------------------------------------
rLoadQ    ROUTINE !Load QUEUE with fictitious data for display.
          DATA
ilLoopNdx LONG
          CODE
          LOOP ilLoopNdx = 1 to 200 !100 queue records.
            Q.Field1 = RANDOM(0,100)

            pMakeString(Q.Field2,LEN(Q.Field2),ilLoopNdx)
            Q.Field2Tip = Q.Field2 !Set tooltip.
              !Choose style for display column one:
            IF NOT (VAL(Q.Field2[6,6]) % 2)
              Q.Field2Sty = 1
            ELSE
              Q.Field2Sty = 2
            END !IF NOT ( Q.Field2[1,1] % 2 )

              !Choose style for display column 2:
            Q.Field3 = RANDOM(0,2000000)
            IF NOT Q.Field3 % 2
              Q.Field3Sty = 3
            ELSE
              Q.Field3Sty = 4
            END !IF NOT ( Q.Field2[1,1] % 2 )

              !Choose tooltip for display column 2:
            IF Q.Field3 > 999999
              Q.Field3Tip = Q.Field3
            ELSE
              Q.Field3Tip = 'Too Low!<0>'
            END !IF Q.Field3 > 999999

            ADD(Q)

          END !LOOP ilLoopNdx = 1 to 10


!---------------------------------------------------------
rSetListFormat  ROUTINE

!'P' in format string declares row/cell tooltip.
!'Y' declares cell style.
!'Sxxx' (S400) declares column scroll bar.
  sField1Format = ''
  sField2Format = '85LPY|M~Field1 (Random Junk)~@S100@#2#S400'
  sField3Format = '50LPY~Field2 (Nbr)~@N10@#5#'

 sFormat = CLIP(sField1Format) & CLIP(sField2Format) & CLIP(sField3Format)

!---------------------------------------------------------
rSetFields ROUTINE

 sMsg1 = 'Demo of LIST FORMAT() ' |
       & 'Styles, Cell Tooltips, and the ' |
       & 'effect of TIMER on tooltip display.  ' |
       & 'Each cell is filled with random garbage ' |
       & 'or a random number.  The style for column 1 ' |
       & 'is selected based on char 5 of the string.'

 sMsg2 = 'The LIST contains a tooltip for each cell.  '  |
       & 'Hover your mouse pointer over any '    |
       & 'cell for a moment and the tooltip will display. ' |
       & 'Once the tooltip appears, move the mouse ' |
       & 'around over the list to have the tip dynamcially ' |
       & 'change as the mouse pointer highlights ' |
       & 'various LIST cells.  ' |
       & 'If you "mess up" the display, press the ' |
       & '[Restore] button.'

 sMsg3 = 'In C5b (or prior), to see a bad LIST FORMAT() bug, ' |
       & 'simply drag the Left Border of Field2 all the ' |
       & 'way to the left "off" the window, then let go.' |
       & '  Press [Restore] to "fix" the FORMAT()'

!---------------------------------------------------------
rSetStyle ROUTINE
   !Set font and color properties for each style.
   !(They are intentionally "ugly" in order to stand out"):

   !Style 1:
 ?List1{PROPSTYLE:FontStyle,1} = FONT:Bold + FONT:underline
 ?List1{PROPSTYLE:FontColor,1} = COLOR:Maroon
 ?List1{PROPSTYLE:FontName,1}  = 'Lucida Handwriting'
 ?List1{PROPSTYLE:FontSize,1}  = 7
 ?List1{PROPSTYLE:BackColor,1} = 0808040H

   !Style 2:
 ?List1{PROPSTYLE:FontStyle,2} = FONT:Italic + FONT:Bold
 ?List1{PROPSTYLE:FontColor,2} = COLOR:Black
 ?List1{PROPSTYLE:FontName,2}  = 'Arial'
 ?List1{PROPSTYLE:FontSize,2}  = 11
 ?List1{PROPSTYLE:BackColor,2} = COLOR:Green

   !Style 3:
 ?List1{PROPSTYLE:FontStyle,3} = FONT:strikeout
 ?List1{PROPSTYLE:FontColor,3} = COLOR:Silver
 ?List1{PROPSTYLE:FontName,3}  = 'Comic Sans MS'
 ?List1{PROPSTYLE:FontSize,3}  = 8
 ?List1{PROPSTYLE:BackColor,3} = COLOR:Red

   !Style 4:

 ?List1{PROPSTYLE:FontStyle,4} = FONT:Bold + FONT:Italic
 ?List1{PROPSTYLE:FontColor,4} = COLOR:White
 ?List1{PROPSTYLE:FontName,4}  = 'MS LineDraw'
 ?List1{PROPSTYLE:FontSize,4}  = 10
 ?List1{PROPSTYLE:BackColor,4} = COLOR:Blue

!---------------------------------------------------------
rTimer    ROUTINE
    !Set windows timer:
  Window{Prop:Timer} = ilSpinTimer
    !Update statusbar:
  Window{Prop:StatusText,1} = 'Window{{Prop:Timer}='  |
                            & Window{Prop:Timer}      |
                            & '   '                   |
                            & FORMAT(ilCounter,@N10)   |
                            & '    '                  |
                            & FORMAT(ilStartTime,@T4) |
                            & '    ' & FORMAT(CLOCK(),@T4)

!---------------------------------------------------------
pMakeString PROCEDURE(*STRING Lclp:String |
                     , LONG Lclp:ilLen    |
                     , LONG Lclp:ilLoopNdx)
!Generate a random "junk" string.
plcl:ilLoopNdx  LONG
  CODE
  CLEAR(Lclp:String)
  Lclp:String = FORMAT(Lclp:ilLoopNdx,@N03)
  LOOP plcl:ilLoopNdx = 6 TO Lclp:ilLen
    Lclp:String[plcl:ilLoopNdx : plcl:ilLoopNdx] = CHR(RANDOM(32,90))
  END !LOOP plcl:ilLoopNdx = 6 TO Lclp:ilLen
  RETURN
!---------------------------------------------------------
![End File]
